---
- name: Mettre à jour les paquets
  apt:
    update_cache: yes
    upgrade: yes
    state: present

- name: Install packages
  package:
    name: "{{ item }}"
  loop:
    - haproxy

- name: Copy haproxy.cfg
  copy:
    src: "../roles/haproxy/files/haproxy.cfg"
    dest: "/etc/haproxy/haproxy.cfg"
    mode: "0644"
  notify:
    - Restart haproxy

### TELEGRAF ###
- name: Copy depots telegraf
  copy:
    src: ../roles/glpi/files/depots.sh
    dest: /usr/local/bin/depots.sh
    owner: debian
    group: debian   
    mode: '0755'
  notify:
    - Run import depots

- meta: flush_handlers

- name: Install Telegraf
  apt:
    name: "{{ item }}"
    state: present
  loop:
    - telegraf

- name: Add line to rsyslog.conf
  lineinfile:
    path: /etc/rsyslog.conf
    line: "*.* @@(o)127.0.0.1:6514;RSYSLOG_SyslogProtocol23Format"
    insertafter: EOF

- name: Restart rsyslog service
  service:
    name: rsyslog
    state: restarted

- name: Copy conf telegraf
  copy:
    src: ../roles/glpi/files/telegraf.conf
    dest: /etc/telegraf/telegraf.conf
    mode: '0644'

- name: Start Telegraf service
  service:
    name: telegraf
    state: started
    enabled: yes

- name: Enable services at boot
  systemd:
    name: "{{ item }}"
    enabled: yes
  loop:
    - telegraf

### Depots pour filebeat & metricbeat ###

- name: Import Elasticsearch GPG key
  apt_key:
    url: https://artifacts.elastic.co/GPG-KEY-elasticsearch

- name: Add Elastic APT repository
  apt_repository:
    repo: deb https://artifacts.elastic.co/packages/8.x/apt stable main
    state: present

- name: Update apt cache
  apt:
    update_cache: yes

### Install filebeat & metricbeat ###
- name: Installation des paquets requis
  apt:
    name: "{{ item }}"
    state: present
  loop:
    - filebeat
    - metricbeat

### Conf filebeat ###
- name: Copy filebeat.yml
  copy:
    src: ../roles/haproxy/slave/files/filebeat.yml
    dest: /etc/filebeat/filebeat.yml
    owner: root
    group: root   
    mode: '0600'

- name: Copy module system.yml
  copy:
    src: ../roles/haproxy/slave/files/filebeat_modules.d/system.yml
    dest: /etc/filebeat/modules.d/system.yml
    owner: root
    group: root   
    mode: '0644'

- name: Setup system module for Filebeat
  ansible.builtin.command: filebeat setup

### Conf metricbeat ###
- name: Copy metricbeat.yml
  copy:
    src: ../roles/haproxy/slave/files/metricbeat.yml
    dest: /etc/metricbeat/metricbeat.yml
    owner: root
    group: root   
    mode: '0600'

- name: Copy module linux.yml
  copy:
    src: ../roles/haproxy/slave/files/metricbeat_modules.d/linux.yml
    dest: /etc/metricbeat/modules.d/linux.yml
    owner: root
    group: root   
    mode: '0644'

- name: Setup linux module for Metricbeat
  ansible.builtin.command: metricbeat setup

- name: Enable services at boot
  systemd:
    name: "{{ item }}"
    enabled: yes
  loop:
    - filebeat
    - metricbeat

- name: Start services
  service:
    name: "{{ item }}"
    state: started
    enabled: yes
  loop:
    - filebeat
    - metricbeat